<?php

namespace Slack\Listeners;

use Illuminate\Support\Facades\Log;
use Illuminate\Contracts\Queue\ShouldQueue;
use Slack\Event\AppHomeOpened;

use App\Jobs\SlackHomeTabUpdate;

class AppHomeOpenedListener implements ShouldQueue
{
	protected const LOGKEY = 'LAH';

	public $queue = 'high';

	/**
	 * Handle the event.
	 *
	 * @param AppHomeOpened $event
	 * @return void
	 */
	public function handle(AppHomeOpened $event)
	{
		// Do some magic with event data
		Log::info(sprintf('%s:App Home Page open for [%s] in team [%s]',self::LOGKEY,$event->user_id,$event->team_id),['m'=>__METHOD__]);

		dispatch((new SlackHomeTabUpdate($event->user(),$event->team(TRUE),$event->tab,$event->view))->onQueue('high'));
	}
}
